# Ananas Build Toolkit 2.0

## Bundled modules

- application
- npm - (install, build)
- bower - (install, build)
- composer - (install, upload)
- scp (upload)
- webpack (install, build)

## Nouveautés

- revamped directory structure (etc/modules, etc/profiles)
- Concentré sur le build

## Stages

- init : makes project compatible with the Ananas Build Toolkit
- install : installs dependencies (composer, npm, etc)
- build : builds project (ORM generation, assets compilation, etc)
- package : creates build archive (phar, tar, etc)
- upload : uploads package to artifact repository
- deploy : deploys local sources to remote servers
- configure : configures sources

## Application module

application.name=myapp
application.domain=mydomain.net
application.host=${application.name}.${application.domain}
application.http.scheme=https

## Package module

package.format=tar

## Environment module

Génération d'un fichier .env à partir la conf en java properties ?

## Formalisme de nommage des targets de module

module.${stage}
module.${stage}.${action}

## Formalisme de nommage des propriété de module

${module}.property

## Formalisme de nommage des propriété de module services

service.${servicetype}.${serviceinstance}.property

eg. :
- service.mysql.master.host
- service.elasticsearch.1.port
- service.rabbitmq.1.user